/************************CASP_COPYRIGHT**********************************
** Copyright (c) AadhunikLabs. All rights reserved.
** This file is part of CASP.
** Licensees holding valid licenses may use this file in accordance
** with the license agreement provided with the software.
*************************************************************************/
#ifndef _BSP_SPI_H_
#define _BSP_SPI_H_

#include "hifive.h"

#define SPI_DUMMY_BYTE                  0x00//0xff//casp
//
#define SPI_MASTER			0
#define SPI_SLAVE			1
//
#define SPI_LSB_FIRST			0
#define SPI_MSB_FIRST			1
//
#define SPI_MODE0			0x00
#define SPI_MODE1			0x01
#define SPI_MODE2			0x02
#define SPI_MODE3			0x03
//
class SPISettings
{
public:
    SPISettings(const _UINT32 clock=1000000, const _BYTE bitOrder=MSBFIRST, const _BYTE dataMode=SPI_MODE0) :_clock(clock), _bitOrder(bitOrder), _dataMode(dataMode) {}
    const _UINT32 _clock;
    const _BYTE  _bitOrder;
    const _BYTE  _dataMode;
};

class SpiComm
{
public:
    SpiComm();
    ~SpiComm();
    void begin();
    void end();
    void setClockDivider(const unsigned short);
    void setBitOrder(const unsigned char);
    void beginTransaction(const SPISettings &settings=SPISettings());
    void endTransaction();
    unsigned char transfer(unsigned char);
    unsigned short transfer16(unsigned short);
    void transfer(unsigned char*, int);//shall be used for send only
    inline void send(unsigned char data){transfer(data);}
    inline unsigned char recv(){return transfer(SPI_DUMMY_BYTE);}
private:
    struct metal_spi *m_spi;
    struct metal_spi_config m_config;
    _BOOLEAN m_bit_order_msb;
};
extern SpiComm SPI;

#endif//_BSP_SPI_H_
