/************************CASP_COPYRIGHT**********************************
** Copyright (c) AadhunikLabs. All rights reserved.
** This file is part of CASP.
** Licensees holding valid licenses may use this file in accordance
** with the license agreement provided with the software.
*************************************************************************/
#ifndef _BSP_WIRE_H_
#define _BSP_WIRE_H_

#include "hifive.h"

#define TWI_BUFFER_LENGTH   32

class TwoWire
{
public:
    TwoWire();
    void begin(_BYTE address = 0);
    void end(void);
    void setClock(_DWORD);
    void beginTransmission(_BYTE);
    _BYTE endTransmission(_BYTE sendStop = TRUE);
    _BYTE requestFrom(_BYTE address, _BYTE quantity, _BYTE sendStop = 1);
    unsigned int write(_BYTE);
    unsigned int write(const _BYTE *, unsigned int);
    int available(void);
    _BYTE read(void);
    _BYTE peek(void);
    void onReceive( void (*)(int) );
    void onRequest( void (*)(void) );
private:
    struct metal_i2c *m_i2c;
    unsigned long m_i2c_base;
    int m_prev_send_byte;
    unsigned char m_send_stop;
    int m_bytes_to_recv, m_bytes_recvd;
    unsigned char m_recvd_byte;
    void (*user_onRequest)(void);
    void (*user_onReceive)(int);

};
extern TwoWire Wire;

#endif//_BSP_WIRE_H_
