/************************CASP_COPYRIGHT**********************************
** Copyright (c) AadhunikLabs. All rights reserved.
** This file is part of CASP.
** Licensees holding valid licenses may use this file in accordance
** with the license agreement provided with the software.
*************************************************************************/
#include "hifive.h"

static volatile unsigned long long g_tick_counter;
static volatile unsigned int g_prev_tick;

void initVariant1()
{
    g_tick_counter = 0;
    g_prev_tick = 0;
    //init interrurpts
    struct metal_interrupt *cpu_intr = 0;
    struct metal_cpu *cpu = metal_cpu_get(metal_cpu_get_current_hartid());
    if(cpu)
        cpu_intr = metal_cpu_interrupt_controller(cpu);
    if(cpu_intr)
        metal_interrupt_init(cpu_intr);
    //metal_interrupt_enable(cpu_intr, 0);
}

void initVariant2()
{
    metal_interrupt_enable(metal_cpu_interrupt_controller(metal_cpu_get(metal_cpu_get_current_hartid())), 0);
}

unsigned long long millis()
{
    return micros()/1000;
}
unsigned long long micros()
{
    unsigned int tick = clock();
    unsigned int diff = 0;
    if(tick < g_prev_tick)
        diff = ((0xffffffff-g_prev_tick)+tick);
    else
        diff = tick-g_prev_tick;
    g_tick_counter += diff;
    g_prev_tick = tick;
    return g_tick_counter;
}

void SystemInit(void)
{
}

void SystemClockInit(void)
{
}

void SystemIOInit(void)
{
}
