/************************CASP_COPYRIGHT**********************************
** Copyright (c) AadhunikLabs. All rights reserved.
** This file is part of CASP.
** Licensees holding valid licenses may use this file in accordance
** with the license agreement provided with the software.
*************************************************************************/
#ifndef _HIFIVE_I2C_DRIVER_H_
#define _HIFIVE_I2C_DRIVER_H_

#include <metal/machine/platform.h>

//Register fields
#define METAL_I2C_CONTROL_EN (1UL << 7)
#define METAL_I2C_CONTROL_IE (1UL << 6)
#define METAL_I2C_WRITE (0UL << 0)
#define METAL_I2C_READ (1UL << 0)
#define METAL_I2C_CMD_START (1UL << 7)
#define METAL_I2C_CMD_STOP (1UL << 6)
#define METAL_I2C_CMD_READ (1UL << 5)
#define METAL_I2C_CMD_WRITE (1UL << 4)
#define METAL_I2C_CMD_ACK (1UL << 3)
#define METAL_I2C_CMD_IACK (1UL << 0)
#define METAL_I2C_STATUS_RXACK (1UL << 7)
#define METAL_I2C_STATUS_BUSY (1UL << 6)
#define METAL_I2C_STATUS_AL (1UL << 5)
#define METAL_I2C_STATUS_TIP (1UL << 1)
#define METAL_I2C_STATUS_IP (1UL << 0)

struct metal_i2c;

#ifdef __cplusplus
extern "C"{
#endif

unsigned long hifive_i2c_driver_get_base_addr(struct metal_i2c *i2c);
int hifive_i2c_driver_write_addr(unsigned long base, unsigned int addr, unsigned char rw_flag);//return -1 for error
int hifive_i2c_driver_write_data(unsigned long base, unsigned char data_byte, unsigned char stop_bit);//return -1 for error
unsigned char hifive_i2c_driver_read_data(unsigned long base, unsigned char stop_bit);

#ifdef __cplusplus
}
#endif

#endif//_HIFIVE_I2C_DRIVER_H_
